using OpenTK.Mathematics;
using OpenTK.Windowing.Common;
using OpenTK.Windowing.Desktop;

namespace GraphicsManager.Interfaces;

public interface IWindow : IParent
{
    public IRenderObject? HoveringControl { get; set; }
    public IGLFWGraphicsContext Context { get; }
    
    public bool ShowMissingChar { get; }
    
    public event Action<MouseButtonEventArgs> MouseDown;
    
    public event Action<FileDropEventArgs> FileDrop;
    
    public event Action<MouseWheelEventArgs> MouseWheel;
    
    public event Action<KeyboardKeyEventArgs> KeyDown;
    
    public event Action<TextInputEventArgs> TextInput;
    public Vector2i Location { get; set; }
    
    public IRenderObject? focused { get; set; }
    
    public string ClipboardString { get; set; }
    
    public string Title { get; set; }
    
    public Vector2 MousePosition { get; set; }
    
    public bool CanControleUpdate { get; }

    void Invoke(Action A);
    
    bool InvokeRequired { get; }
}