﻿using System.Diagnostics;
using System.Reflection;
using System.Security.Cryptography;
using SharpFont;

namespace GraphicsManager.Objects.Core;

public class Font
{
	internal static Library lib = new();
	public Face Face { get; private set; }
	

	private Font()
	{
	}

	internal static Font MakeFontFromFile(string Font)
	{
		try
		{
			_ = Font ?? throw new ArgumentNullException(nameof(Font));
			Font fontclass = new Font();
			fontclass.Face = new Face(lib, Font, 0);
			return fontclass;
		}
		catch (Exception e)
		{
			Console.WriteLine(e);
			throw;
		}
	}
	
	
	internal static Font MakeFontFromStream(MemoryStream Font)
	{
		_ = Font ?? throw new ArgumentNullException(nameof(Font));
		Font fontclass = new Font();
		fontclass.Face = new Face(lib, Font.ToArray(), 0);
		return fontclass;
	}
}
