﻿using System.Diagnostics;
using System.Reflection;

namespace GraphicsManager;

public class Tools
{
	public static void AddFontsToList(ref List<string> List, string folder)
	{
		DirectoryInfo di = new(folder);
		foreach (FileInfo file in di.GetFiles())
		{
			if (!file.FullName.EndsWith(".otf") && !file.FullName.EndsWith(".ttf")) continue;
			
			List.Add(file.FullName);
		}
		foreach (DirectoryInfo direc in di.GetDirectories())
		{
			AddFontsToList(ref List, direc.FullName);
		}
	}

	public static string[] GetFamilyList(string Command)
	{
		Process proc = new()
		{
			StartInfo = new()
			{
				FileName = "/bin/bash",
				Arguments = $"-c \"{Command}\"",
				RedirectStandardOutput = true,
			}
		};
		proc.Start();
		proc.WaitForExit();
		List<string> bbb = proc.StandardOutput.ReadToEnd().Split($"{Environment.NewLine}").ToList();
		bbb.RemoveAt(bbb.Count - 1);
		return bbb.ToArray();
	}

	public static string[] GetFontList(string Command)
	{
		Process proc = new()
		{
			StartInfo = new()
			{
				FileName = "/bin/bash",
				Arguments = $"-c \"{Command}\"",
				RedirectStandardOutput = true,
			}
		};
		proc.Start();
		proc.WaitForExit();
		List<string> bbb = proc.StandardOutput.ReadToEnd().Split($": {Environment.NewLine}").ToList();
		bbb.RemoveAt(bbb.Count - 1);
		return bbb.ToArray();
	}
	
	public static byte[] GetResourceBytes(Assembly Assembly, string Resource)
	{
		Stream str = Assembly.GetManifestResourceStream(Resource)!;
		MemoryStream ms = new();
		str.CopyTo(ms);
		str.Dispose();
		byte[] result = ms.ToArray();
		ms.Dispose();
		return result;
	}
	
	public static Stream GetResourceStream(Assembly Assembly, string Resource)
	{
		Stream str = Assembly.GetManifestResourceStream(Resource)!;
		return str;
	}

	public static string GetResourceString(Assembly Assembly, string Resource)
	{
		Stream str = Assembly.GetManifestResourceStream(Resource)!;
		StreamReader sr = new(str);
		string result = sr.ReadToEnd();
		sr.Dispose();
		str.Dispose();
		return result;
	}

	public static Stream GetResourceStream(string Resource) => GetResourceStream(typeof(Tools).Assembly, Resource);
	
	public static byte[] GetResourceBytes(string Resource) => GetResourceBytes(typeof(Tools).Assembly, Resource);

	public static string GetResourceString(string Resource) => GetResourceString(typeof(Tools).Assembly, Resource);
}
